// Name
// Student ID

// This is the main program for Lab 08.  You don't need to change any of
// the code in this tab, except for adding your name and student ID number
// to the comments above.  The purpose of this tab is to set up the sketch
// and construct a UI that can display the solutions to the individual word
// puzzles in the other tab.

import controlP5.*;

// The ControlP5 factory and two UI elements: a text label to tell
// you what mode you're in, and a scrollable text area to show all
// the words found in that mode.
ControlP5 ui;
Textlabel label;
Textarea area;

// Store an array of all English words.
String[] words;

// Also construct an IntDict with these words as keys,
// which will allow us to check if strings are words
// very quickly.
IntDict word_dict;

// Which mode are we currently in?
int mode = 0;
// How many modes are there in all?
int num_modes = 7;

void setup()
{
  size( 400, 400 );

  // Get the word list
  words = loadStrings( "words.txt" );
  
  // Also build a dictionary data structure
  word_dict = new IntDict();
   
  for( int idx = 0; idx < words.length; ++idx ) {
    word_dict.set( words[idx], 1 );
  }

  // Set up the user interface
  ui = new ControlP5( this );

  label = ui.addTextlabel( "Mode" )
    .setPosition( 5, 5 )
    .setSize( 390, 40 )
    .setFont( createFont( "arial", 24 ) )
    .setColor( color( 255, 255, 255 ) );

  area = ui.addTextarea( "Words" )
    .setPosition( 5, 50 )
    .setSize( 390, 345 )
    .setFont( createFont( "arial", 24 ) )
    .setColor( color( 255, 255, 255 ) );

  setMode( 0 );
}

void draw()
{
  background( 50 );
}

void setMode( int mode_number )
{
  String[] result = null;

  // This is a bit ugly.  There are nicer ways to set up code
  // like this, but they're beyond the scope of CS 106.
  if ( mode_number == 0 ) {
    label.setText( "0: 24+ Letters" );
    result = getWords_0();
  } else if ( mode_number == 1 ) {
    label.setText( "1: Start and end with th" );
    result = getWords_1();
  } else if ( mode_number == 2 ) {
    label.setText( "2: Contain a, e, i, o, u" );
    result = getWords_2();
  } else if ( mode_number == 3 ) {
    label.setText( "3: Alphabetical order" );
    result = getWords_3();
  } else if ( mode_number == 4 ) {
    label.setText( "4: No repeated letters" );
    result = getWords_4();
  } else if( mode_number == 5 ) {
    label.setText( "5: Move two letters, still a word" );
    result = getWords_5();
  } else if ( mode_number == 6 ) {
    label.setText( "6: Vowels in order" );
    result = getWords_6();
  }

  area.setText( join( result, '\n' ) );
}

// Press a key to cycle through modes.
void keyPressed()
{
  if ( key == ' ' ) {
    mode = (mode + 1) % num_modes;
    setMode( mode );
  }
}
